/******************************************************************************/
/*									      */
/* [PSXg[ANZXvOC]					      */
/*									      */
/*	FILE NAME	: Plugin.c   					      */
/*	FUNCTION	: FF8[r[				      */
/*									      */
/*	FUNCTIONS		| an outline				      */
/*    --------------------------+-------------------------------------------- */
/*	PsrQueryPlugin()	| vOC̎擾			      */
/*	PsrIsSupportCDBegin()	| CDT|[g Jn		      */
/*	PsrIsSupportCDEnd()	| CDT|[g I		      */
/*	PsrIsSupportCDSector()	| CDT|[g ZN^ʒm		      */
/*	PsrIsSupportCDResult()	| CDT|[g ʎ擾		      */
/*	PsrGetStrDataInfo()	| Xg[f[^̎擾		      */
/*	PsrOpenCD()		| CDXg[̃I[v		      */
/*	PsrClose()		| Xg[f[^̃N[Y		      */
/*	PsrRead()		| Xg[f[^̓ǂݎ		      */
/*	PsrSeek()		| ǂݎʒu̐ݒ			      */
/*	PsrDecodeAudio()	| f[^̃fR[h			      */
/*									      */
/*	HISTORY		| Comment				| Name	      */
/*    ------------------+---------------------------------------+------------ */
/*	2000.06.12	| VK쐬				| ӂ      */
/*	2000.07.11	| PSRPLUGIN\̂̕ύX		1.10	| ӂ      */
/*	2000.07.12	| CD͒fp̒ǉ	1.10	| ӂ      */
/*	2000.08.08	| vOCdlύX		1.20	| ӂ      */
/*	2000.08.13	| ŏIt[擾s\΍	1.21	| ӂ      */
/*	2000.10.28	| vOCdlύX		1.30	| ӂ      */
/*									      */
/*			(C) Copyright ӂ 2000. All rights reserved.       */
/******************************************************************************/

#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <Windows.h>

#include "CdAccess.h"
#include "PSRP.h"


typedef struct {	// ZN^[\ ----------------------------------------
	BYTE		acCdxa[24];		// CD-ROM XA
	BYTE		abHead[4];		// SM*\1
	BYTE		bSectNo;		// ZN^ԍ	0`
	BYTE		bLastSectNo;		// t[ŏIZN^ԍ
	USHORT		usFrameNo;		// t[ԍ	0`
	BYTE		abData[2040];		// f[^
	BYTE		abEdc[4];		// EDC
	BYTE		abPParity[172];		// PpeB
	BYTE		abQParity[104];		// QpeB
} _TSECTOR, *_PTSECTOR;


typedef struct {	// Xg[ --------------------------------------
	WORD		wTypeFlags;	// f[^ʃtO	PSR_STRTYPE_XXX
	WORD		wNumFrame;	// t[
	WORD		wUSector;	// t[̃ZN^
	DWORD		dwBeginningPos;	// f[^JnZN^ԍ
} _TSTREAM, *_PTSTREAM;


typedef struct {	// Xg[Tnh̓e ------------------------
	BOOL		fFindout;	// tO
	INT		iBuffer;	// Xg[obt@
	INT		iNum;		// Xg[
	_PTSTREAM	pstr;		// Xg[Q
} _TFIND, *_PTFIND;


typedef struct {	// Xg[nh̓e ----------------------------
	HANDLE		hCdrom;		// CD-ROMnh
	DWORD		nBeginning;	// Xg[Jnʒu
	DWORD		nNumSector;	// cZN^
	WORD		wNumFrame;	// t[
	WORD		wSectPerFrame;	// t[̃ZN^
	_PTSECTOR	psector;	// ޔZN^
} _THANDLE, *_PTHANDLE;


typedef struct {	// WAVEvf --------------------------------------------
	SHORT		sLeft;
	SHORT		sRight;
} _WAVEELM, *_PWAVEELM;


			// ADPCMpW -----------------------------------------
static INT	aiFILTER0[] = {0x0000, 0x00f0, 0x01cc, 0x0188, 0x01e8 };
static INT	aiFILTER1[] = {0x0000, 0x0000, -0x00d0, -0x00dc, -0x00f0 };

#define _ROUND(val)	(min(0x7fffL, max(-0x8000L, val)))

/******************************************************************************/
/*									      */
/*	PsrQueryPlugin() : vOC̎擾				      */
/*									      */
/******************************************************************************/

CEXPORT	VOID	PsrQueryPlugin(
	LPPSRPLUGIN	lpPlugin)	// vOC擾obt@AhX
{
	strcpy(lpPlugin->aName,      "FF8 Stream");
	strcpy(lpPlugin->aCopyright, "Copyright (c) Fyiro 2000.");
	lpPlugin->usVersion	     = 130;			// 1.10
	lpPlugin->usIsSupportVersion = 0;			// 1.10
	lpPlugin->usSystemVersion    = PSR_SYSTEMVERSION;	// 1.10
	strcpy(lpPlugin->aSiteName, "Fyiro's Garage");		// 1.30
	strcpy(lpPlugin->aSiteUrl, "http://homepage2.nifty.com/~mkb/");	// 1.30
}



/******************************************************************************/
/*									      */
/*	PsrIsSupportCDBegin() : CDT|[g Jn			      */
/*									      */
/******************************************************************************/

CEXPORT HANDLE	PsrIsSupportCDBegin(
	INT		iNumToc,	// TOC̐
	LPTOCENTRY	lptoc)		// TOC
{
	_PTFIND		pfind;


	if(iNumToc != 1)		return NULL;
	if(!(lptoc[0].bAdr & 0x04))	return NULL;	// CD-DA

	if(!(pfind = malloc(sizeof(_TFIND))))	return NULL;

			// nh̍쐬Əݒ ----------------------------
	pfind->fFindout	= FALSE;
	pfind->iBuffer	= 10;
	pfind->iNum	= 0;
	pfind->pstr	= malloc(sizeof(_TSTREAM) * pfind->iBuffer);
	if(!pfind->pstr) {
		free(pfind);
		return NULL;
	}
	return pfind;
}



/******************************************************************************/
/*									      */
/*	PsrIsSupportCDEnd() : CDT|[g I			      */
/*									      */
/******************************************************************************/

CEXPORT	VOID	PsrIsSupportCDEnd(
	HANDLE		hIsCD)		// CDT|[gnh
{
	_PTFIND		pfind;


	if(!(pfind = hIsCD))	return;
	free(pfind->pstr);
	free(pfind);
}

/******************************************************************************/
/*									      */
/*	PsrIsSupportCDSector() : CDT|[g ZN^ʒm		      */
/*									      */
/******************************************************************************/

CEXPORT	BOOL	PsrIsSupportCDSector(
	HANDLE		hIsCD,		// CDT|[gnh
	TOCENTRY	toc,		// TOC
	DWORD		nSector,	// ZN^ԍ
	PVOID		pvSector)	// ZN^
{
	_PTFIND		pfind;
	_PTSECTOR	psector;
	_PTSTREAM	pstr;
	BOOL		fStream, fBegin;


	if(!(pfind = hIsCD))	return FALSE;
	if(!(psector = pvSector)) {					// 1.10
		if(pfind->fFindout) {					// 1.10
			pfind->fFindout = FALSE;			// 1.10
			pfind->iNum --;					// 1.10
		}							// 1.10
		return FALSE;						// 1.10
	}								// 1.10


	fStream = FALSE;// Xg[̃ZN^? -------------------------------
	if(memcmp(psector->abHead, "SM", 2) == 0) {
		if(psector->abHead[3] == 1) {
			if(psector->bLastSectNo) {
				fStream = TRUE;
			}
		}
	}

	fBegin = FALSE;	// 擪ZN^? ---------------------------------------
	if(fStream && !psector->bSectNo && !psector->usFrameNo) {
		fBegin = TRUE;
	}

	if(!pfind->fFindout && !fBegin)	fStream = FALSE;

// Xg[Ăꍇ **********************************************

	if(pfind->fFindout) {
		pstr = &pfind->pstr[pfind->iNum - 1];

		if(!fStream || fBegin) {
			pfind->fFindout = FALSE; 	// I!
			if(!pstr->wNumFrame)	pfind->iNum --;
		}
		else {
			if(psector->bSectNo == psector->bLastSectNo) {
				pstr->wNumFrame = psector->usFrameNo + 1;
			}
			if(psector->abHead[2] == 'J') {
				pstr->wTypeFlags |= PSR_STRTYPE_MOVIE;
			}
		}
	}

// Xg[ĂȂꍇ ********************************************

	if(!pfind->fFindout && fBegin) {

			// Xg[! -----------------------------
		if(pfind->iBuffer == pfind->iNum) {
			pfind->iBuffer += 10;
			pstr = realloc(pfind->pstr,
					sizeof(_TSTREAM) * pfind->iBuffer);
			if(!pstr) {
				pfind->iBuffer -= 10;
				return TRUE;	// Ƃ肠I
			}
			pfind->pstr = pstr;
		}

		pstr = &pfind->pstr[pfind->iNum];
		pstr->wTypeFlags	= PSR_STRTYPE_AUDIO;
		pstr->wNumFrame		= 0;	// l
		pstr->wUSector		= psector->bLastSectNo + 1;
		pstr->dwBeginningPos	= nSector;
		pfind->fFindout	= TRUE;
		pfind->iNum ++;
	}

	return TRUE;
}

/******************************************************************************/
/*									      */
/*	PsrIsSupportCDResult() : CDT|[g ʎ擾		      */
/*									      */
/******************************************************************************/

CEXPORT	INT	PsrIsSupportCDResult(
	HANDLE		hIsCD,		// CDT|[gnh
	INT		iIndex,		// Xg[CfbNX
	LPPSRSTREAMINFO	lpStreamInfo)	// Xg[f[^
{
	_PTFIND		pfind;
	_PTSTREAM	pstr;


	if(!(pfind = hIsCD))		return 0;
	if(pfind->iNum <= iIndex)	return -1;

	if(lpStreamInfo) {
		pstr = &pfind->pstr[iIndex];
		lpStreamInfo->wTypeFlags	= pstr->wTypeFlags;
		lpStreamInfo->wReserved		= 0;
		lpStreamInfo->nBeginSector	= pstr->dwBeginningPos;
		lpStreamInfo->nNumSector	= (DWORD)pstr->wNumFrame *
							(DWORD)pstr->wUSector;
		lpStreamInfo->nNumFrame		= (DWORD)pstr->wNumFrame;
		lpStreamInfo->nPlayTime		= ((DWORD)pstr->wNumFrame * 1000) / 15;
		lpStreamInfo->szFrame.cx	= 0x140;
		lpStreamInfo->szFrame.cy	= 0x0e0;
		lpStreamInfo->wFrameRate	= 150;
		lpStreamInfo->wFormatTag	= WAVE_FORMAT_PCM;
		lpStreamInfo->wChannels		= 2;
		lpStreamInfo->wBitsPerSample	= 16;
		lpStreamInfo->nSamplesPerSec	= 44100;
		lpStreamInfo->nDataSize		= lpStreamInfo->nNumSector * 2040;	// 1.30
	}

	return pfind->iNum;
}

/******************************************************************************/
/*									      */
/*	PsrGetStrDataInfo() : Xg[f[^̎擾		      */
/*									      */
/******************************************************************************/

CEXPORT	BOOL	PsrGetStrDataInfo(
	INT		iDriveNo,	// hCuԍ
	DWORD		dwBegin,	// JnZN^ԍ
	DWORD		dwNumSector,	// ZN^
	LPPSRSTREAMINFO	lpStreamInfo)	// Xg[f[^
{
	HANDLE		hCdrom;
	_PTSECTOR	psector;
	INT		iSectPerFrame;
	WORD		wTypeFlags;

			// 擪̃ZN^ǂݎ ----------------------------
	hCdrom = CdReadOpen(iDriveNo, NULL, dwBegin, 4, -1);
	if(!hCdrom)	return FALSE;

	iSectPerFrame	= 0;
	wTypeFlags	= 0;
	while(psector = CdReadSector(hCdrom, NULL)) {
		if(memcmp(psector->abHead, "SM", 2) == 0 &&
		   psector->abHead[3] == 1 && psector->bLastSectNo) {
			iSectPerFrame = psector->bLastSectNo + 1;
			if(psector->abHead[2] == 'N' ||
			   psector->abHead[2] == 'R')
				wTypeFlags |= PSR_STRTYPE_AUDIO;
			else if(psector->abHead[2] == 'J')
				wTypeFlags |= PSR_STRTYPE_MOVIE;
		}
		CdUnlockReadBuffer(hCdrom, psector);
	}
	CdReadClose(hCdrom);
	if(!iSectPerFrame || !wTypeFlags)	return FALSE;

			// Xg[f[^쐬 ----------------------
	lpStreamInfo->wTypeFlags	= wTypeFlags;
	lpStreamInfo->wReserved		= 0;
	lpStreamInfo->nBeginSector	= dwBegin;
	lpStreamInfo->nNumSector	= dwNumSector;
	lpStreamInfo->nNumFrame		= dwNumSector / iSectPerFrame;
	lpStreamInfo->nPlayTime		= (lpStreamInfo->nNumFrame * 1000) / 15;
	if(wTypeFlags & PSR_STRTYPE_MOVIE) {
		lpStreamInfo->szFrame.cx	= 0x140;
		lpStreamInfo->szFrame.cy	= 0x0e0;
		lpStreamInfo->wFrameRate	= 150;
	} else {
		lpStreamInfo->szFrame.cx	= 0;
		lpStreamInfo->szFrame.cy	= 0;
		lpStreamInfo->wFrameRate	= 0;
	}
	if(wTypeFlags & PSR_STRTYPE_AUDIO) {
		lpStreamInfo->wFormatTag	= WAVE_FORMAT_PCM;
		lpStreamInfo->wChannels		= 2;
		lpStreamInfo->wBitsPerSample	= 16;
		lpStreamInfo->nSamplesPerSec	= 44100;
	} else {
		lpStreamInfo->wFormatTag	= 0;
		lpStreamInfo->wChannels		= 0;
		lpStreamInfo->wBitsPerSample	= 0;
		lpStreamInfo->nSamplesPerSec	= 0;
	}
	lpStreamInfo->nDataSize		= lpStreamInfo->nNumSector * 2040;//1.30
	return TRUE;
}

/******************************************************************************/
/*									      */
/*	PsrOpenCD() : CDXg[̃I[v				      */
/*									      */
/******************************************************************************/

CEXPORT HANDLE	PsrOpenCD(
	INT		iDriveNo,	// hCuԍ
	LPPSRSTREAMINFO	lpStreamInfo)	// Xg[f[^
{
	_PTHANDLE	phandle;
	HANDLE		hCdrom;


			// CD-ROM̃I[v ------------------------------------
	hCdrom = CdReadOpen(iDriveNo, NULL,
				lpStreamInfo->nBeginSector,
				lpStreamInfo->nNumSector, -1);
	if(!hCdrom)	return NULL;

			// nh쐬 --------------------------------------
	if(!(phandle = malloc(sizeof(_THANDLE)))) {
		CdReadClose(hCdrom);
		return NULL;
	}
	phandle->hCdrom		= hCdrom;
	phandle->nBeginning	= lpStreamInfo->nBeginSector;
	phandle->wSectPerFrame	= (WORD)(lpStreamInfo->nNumSector /
						lpStreamInfo->nNumFrame);
	phandle->wNumFrame	= (WORD)lpStreamInfo->nNumFrame;
	phandle->psector	= NULL;
	PsrDecodeAudio(NULL, NULL, 0);

	return phandle;
}

/******************************************************************************/
/*									      */
/*	PsrClose() : Xg[f[^̃N[Y				      */
/*									      */
/******************************************************************************/

CEXPORT BOOL	PsrClose(
	HANDLE		hStream)	// Xg[nh
{
	_PTHANDLE	phandle;


	phandle = hStream;
	if(phandle->hCdrom)	CdReadClose(phandle->hCdrom);
	free(phandle);
	return TRUE;
}

/******************************************************************************/
/*									      */
/*	PsrRead() : Xg[f[^̓ǂݎ				      */
/*									      */
/******************************************************************************/

CEXPORT BOOL	PsrRead(
	HANDLE		hStream,	// Xg[nh
	LPPSRREADBUFF	lpBuffer)	// ǂݎobt@
{
	_PTHANDLE	phandle;
	_PTSECTOR	psector;
	INT		iPos, iSize;
	PBYTE		pbBuff;
	WORD		wType, wNumSect;


	phandle = hStream;
	memset(lpBuffer, 0, sizeof(PSRREADBUFF) - PSR_FRAMEBUFFER);
	pbBuff	= lpBuffer->abData;
	wType	= 0;
	wNumSect= 0;

			// ޔobt@̓eݒ ----------------------------
	if(phandle->psector) {
		psector = phandle->psector;
		phandle->psector = NULL;
		if(psector->abHead[2] == 'N') {
			iPos	= 0x168;
			wType	= PSR_STRTYPE_AUDIO;
		} else if(psector->abHead[2] == 'J') {
			iPos	= 0;
			wType	= PSR_STRTYPE_MOVIE;
			lpBuffer->nFrameNo	= psector->usFrameNo + 1;
			lpBuffer->szFrame.cx	= 0x140;
			lpBuffer->szFrame.cy	= 0x0e0;
		} else {
			// ####
		}
		iSize	= sizeof(psector->abData) - iPos;
		memcpy(pbBuff, &psector->abData[iPos], iSize);
		CdUnlockReadBuffer(phandle->hCdrom, psector);
		pbBuff += iSize;
		lpBuffer->nLength += iSize;
		wNumSect = 1;
	}

	while(1) {	// CDǂݍŐݒ --------------------------------
		if(!(psector = CdReadSector(phandle->hCdrom, NULL)))	break;

				// f[^ - - - - - - - - - - - - - - - - -
		if(psector->abHead[2] == 'N' || psector->abHead[2] == 'R') {
			if(wType & PSR_STRTYPE_MOVIE) {
				phandle->psector = psector;
				break;
			}
			iPos	= 0x168;
			wType	= PSR_STRTYPE_AUDIO;
		}

				// ff[^ - - - - - - - - - - - - - - - - -
		else if(psector->abHead[2] == 'J') {
			if(wType & PSR_STRTYPE_AUDIO) {
				phandle->psector = psector;
				break;
			}
			iPos	= 0;
			wType	= PSR_STRTYPE_MOVIE;
			lpBuffer->nFrameNo	= psector->usFrameNo + 1;
			lpBuffer->szFrame.cx	= 0x140;
			lpBuffer->szFrame.cy	= 0x0e0;
		} else {
			// ####
		}
		iSize	= sizeof(psector->abData) - iPos;
		memcpy(pbBuff, &psector->abData[iPos], iSize);
		CdUnlockReadBuffer(phandle->hCdrom, psector);
		pbBuff += iSize;
		lpBuffer->nLength += iSize;
		wNumSect ++;
		if(wNumSect >= phandle->wSectPerFrame)	break;
	}

	return (lpBuffer->nLength ? TRUE : FALSE);
}

/******************************************************************************/
/*									      */
/*	PsrSeek() : ǂݎʒu̐ݒ					      */
/*									      */
/******************************************************************************/

CEXPORT BOOL	PsrSeek(
	HANDLE		hStream,	// Xg[nh
	DWORD		dwPosition)	// ǂݎʒu		1/1000bP
{
	_PTHANDLE	phandle;
	LONG		lSector;


	phandle = hStream;
	lSector	= ((dwPosition * 15) / 1000) * (LONG)phandle->wSectPerFrame;

	if(phandle->psector) {
		CdUnlockReadBuffer(phandle->hCdrom, phandle->psector);
		phandle->psector    = NULL;
	}
	if(CdSetReadPointer(phandle->hCdrom, lSector, FILE_BEGIN) == 0xffffffff) {
		return FALSE;
	}

	PsrDecodeAudio(NULL, NULL, 0);
	return TRUE;
}

/******************************************************************************/
/*									      */
/*	PsrDecodeAudio() : f[^̃fR[h				      */
/*									      */
/******************************************************************************/

CEXPORT DWORD	PsrDecodeAudio(
	LPPSRREADBUFF	lpAudio,	// f[^
	PVOID		pvBuffer,	// fR[h̉f[^
	DWORD		nLength)	// lpBuffer̃oCg
{
	static LONG	alPRE_L[2], alPRE_R[2];
	DWORD		nSize;
	INT		i, j, k, iTmp;
	INT		iScaleL, iScaleR, iIndexL, iIndexR;
	INT		aiFilterL[2], aiFilterR[2];
	INT		aiValL[2], aiValR[2];
	_PWAVEELM	pwave;
	PBYTE		pbLeft, pbRight;


	if(!lpAudio) {
		alPRE_L[0] = alPRE_L[1] = 0;
		alPRE_R[0] = alPRE_R[1] = 0;
		return 0;
	}
	pwave	= pvBuffer;
	nSize	= sizeof(_WAVEELM) * 0x69 * 14 * 2;
	if(nLength < nSize)	return nSize;

	pbLeft	= lpAudio->abData;
	pbRight	= lpAudio->abData + 0x690;

	for(i=0; i<0x69; i++) {
		iScaleL	= 0x0c - (pbLeft[0] & 0x0f);
		iIndexL	= (pbLeft[0] >> 4);
		aiFilterL[0] = aiFILTER0[iIndexL];
		aiFilterL[1] = aiFILTER1[iIndexL];

		iScaleR	= 0x0c - (pbRight[0] & 0x0f);
		iIndexR	= (pbRight[0] >> 4);
		aiFilterR[0] = aiFILTER0[iIndexR];
		aiFilterR[1] = aiFILTER1[iIndexR];

		pbLeft	+= 2;
		pbRight	+= 2;

		for(j=0; j<14; j++, pbLeft++, pbRight++) {
			aiValL[0] = (pbLeft[0] & 0x0f);
			aiValL[1] = (pbLeft[0] >> 4);
			aiValR[0] = (pbRight[0] & 0x0f);
			aiValR[1] = (pbRight[0] >> 4);
			for(k=0; k<2; k++, pwave++) {
				if(aiValL[k] >= 8)	aiValL[k] -= 16;
				iTmp = (aiValL[k] << iScaleL);
				iTmp += ((alPRE_L[0] * aiFilterL[0] +
					  alPRE_L[1] * aiFilterL[1]) >> 8);
				alPRE_L[1] = alPRE_L[0];
				alPRE_L[0] = _ROUND(iTmp);
				pwave[0].sLeft = (SHORT)alPRE_L[0];

				if(aiValR[k] >= 8)	aiValR[k] -= 16;
				iTmp = (aiValR[k] << iScaleR);
				iTmp += ((alPRE_R[0] * aiFilterR[0] +
					  alPRE_R[1] * aiFilterR[1]) >> 8);
				alPRE_R[1] = alPRE_R[0];
				alPRE_R[0] = _ROUND(iTmp);
				pwave[0].sRight = (SHORT)alPRE_R[0];
			}
		}
	}
	return nSize;
}
